import java.io.*;
import java.util.*;

class InvalidFileException extends Exception {

		public String getMessage () {
				return new String ("InvalidFileException");
		}
		public void printStackTrace () {
				System.out.println("InvalidFileException\n");
				super.printStackTrace();
		}

}


public class FilmCollection implements Serializable {
		
		private LinkedList<Film> theList;
		
		public FilmCollection () {
				theList = new LinkedList<Film>();
		}

		public FilmCollection (String filename) throws InvalidFileException{
				// Load a serialized LinkedList object....
				loadFromFile(filename);
		}
		
		public void loadFromFile (String filename) throws InvalidFileException {
				
				try {
						ObjectInputStream i = 
								new ObjectInputStream (new FileInputStream (filename));
						theList = (LinkedList<Film>) i.readObject ();
						i.close();
				}
				catch (Exception e){
						e.printStackTrace();
						throw new InvalidFileException ();
				}
		}
		
		public void saveToFile (String filename) throws InvalidFileException {
				
				try {

						ObjectOutputStream out = 
								new ObjectOutputStream (new FileOutputStream (filename));
						out.writeObject(theList);
						out.close();
				}
				catch (Exception e){
						e.printStackTrace();
				}
				
		}
		
		public void addFilm (Film __theFilm) {
				
				ListIterator li = theList.listIterator();
				String s = __theFilm.getTitle();
				while( li.hasNext()){
						Film s1 = (Film)li.next();
						if (s.compareTo(s1.getTitle()) < 0){
								li.previous();
								li.add(__theFilm); 
								return;
						}
				}
				theList.add(__theFilm);
		}
		
		public Film getFirst (){
				return theList.getFirst();
		}
		
		public Film getFilmAt (int __pos) {
				return theList.get(__pos);
		}
		
		public int getSize () {
				return theList.size();
		}
		public void deleteFilm (int index){

				theList.remove(index);
		}
		
}

