import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


public class GUI extends JFrame {
		
		private int index;
		private FilmCollection fc;
		private JButton b1, b2, b3, b4, b5, b6, b7;
		private JPanel fieldPanel, funcPanel;
		private JLabel l0, l1, l2, l3, l4, lID;
		private JTextField tTitle, tAuthor, tYear, tCategory;
		private JFileChooser openFile;
		
		private int actIndex;

		private void showFilm (int index) {
				
				Film f = fc.getFilmAt (index);
				lID.setText(Integer.toString(index));
				tTitle.setText(f.getTitle());
				tAuthor.setText(f.getAuthor());
				tYear.setText(f.getYear());
				tCategory.setText (f.getCategory());
		}

		private void deleteFilm (int index){

				fc.deleteFilm(index);
				lID.setText("");
				tTitle.setText("");
				tAuthor.setText("");
				tYear.setText("");
				tCategory.setText ("");
				
		}

		private void showEmptyFilm() {
				
		}
		
		private class MyActionListener implements ActionListener{
				
				public void actionPerformed(ActionEvent __theEvent){
						
						String s = ((Component)__theEvent.getSource()).getName();
						
						if (s.compareTo("prev") == 0){
								
								b4.setEnabled(true);
								if (actIndex >= 0) {
										showFilm(--actIndex);
								}
								if (actIndex == 0){
										b3.setEnabled(false);
								}
								
						}
						else if (s.compareTo("next") == 0){
								
								if (actIndex < fc.getSize()){
										actIndex++;
										showFilm(actIndex);
								}
								if (actIndex == fc.getSize() - 1)
										b4.setEnabled(false);
								
								if (actIndex == 1){
										b3.setEnabled(true);
								}

						}
						else if (s.compareTo("new") == 0){
								
								if (tTitle.getText().length() > 0){
										fc.addFilm(
															 new Film( tTitle.getText(),
																				 tAuthor.getText(),
																				 Integer.parseInt(tYear.getText()),
																				 tCategory.getText())
															 );
										
										if (fc.getSize() > 1){
												b4.setEnabled(true);
										}
										b2.setEnabled(true);
										b3.setEnabled(false);
										b5.setEnabled(true);
										b6.setEnabled(true);
										actIndex = 0;
										showFilm(0);
								}
								
						}
						else if (s.compareTo("delete") == 0){
								
								if (actIndex >= 0){
										deleteFilm(actIndex);
									 
										if (fc.getSize() == 0){
												showEmptyFilm();
												b4.setEnabled(false);
												b6.setEnabled(false);
										}
										else{
												actIndex = 0;
												showFilm(actIndex);
										}
										b3.setEnabled(false);
										
										if (fc.getSize() > 1){
												b4.setEnabled(true);
										}
										if (fc.getSize() == 1){
												b2.setEnabled(false);
										}
								}
						}
						else if (s.compareTo("save") == 0){
								int ret = 
										openFile.showSaveDialog((Component) __theEvent.getSource());
								if (ret == JFileChooser.APPROVE_OPTION){
										try {
												fc.saveToFile(openFile.getSelectedFile().getName());
										}
										catch (Exception e){
												e.printStackTrace();
										}
								}
								
						}
						else if (s.compareTo("open") == 0){
								int ret = 
										openFile.showOpenDialog((Component) __theEvent.getSource());
								if (ret == JFileChooser.APPROVE_OPTION){
										try{
												// Unserialize object
												fc = new FilmCollection();
												fc.loadFromFile(openFile.getSelectedFile().getName());
												actIndex = 0;
												showFilm(actIndex);
												// Activate other buttons 
												b2.setEnabled(true);
												b3.setEnabled(false);
												b4.setEnabled(true);
												b5.setEnabled(true);
												b6.setEnabled(true);
												
										}
										catch (Exception e){
												e.printStackTrace();
										}
								}
						}
						else if (s.compareTo("quit") == 0){
								System.exit(0);
						}
						else {
								System.out.println("Unrecognized event...");
						}
				}
		}
		
		private void buildGUI () {
				
				actIndex = -1;
				Container c = this.getContentPane();
				this.setDefaultCloseOperation(EXIT_ON_CLOSE);
				//this.setPreferredSize(new Dimension(400,400));
				this.setTitle ("My Film Collection");
				
				openFile = new JFileChooser();
				
				MyActionListener mal = new MyActionListener();
				GridBagLayout gbl = new GridBagLayout();
				GridBagConstraints gbc = new GridBagConstraints();
				
				setLayout(gbl);
				gbc.fill = GridBagConstraints.BOTH;
				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx= 0.0;
				gbc.weighty= 0.0;
				fieldPanel = new JPanel();
				funcPanel = new JPanel();
				fieldPanel.setLayout(gbl);
				funcPanel.setLayout(gbl);

				l0 = new JLabel("ID: ");
				lID = new JLabel(" ");
				l1 = new JLabel("Titolo: ");
				l2 = new JLabel("Autore: ");
				l3 = new JLabel("Anno: ");
				l4 = new JLabel("Genere: ");
				
				l0.setPreferredSize(new Dimension(100,30));
				l1.setPreferredSize(new Dimension(100,30));
				l2.setPreferredSize(new Dimension(100,30));
				l3.setPreferredSize(new Dimension(100,30));
				l4.setPreferredSize(new Dimension(100,30));
				
				tTitle = new JTextField();
				tAuthor = new JTextField();
				tYear = new JTextField();
				tCategory = new JTextField();
				
				tTitle.setPreferredSize(new Dimension (200, 30));
				tAuthor.setPreferredSize(new Dimension (200, 30));
				tYear.setPreferredSize(new Dimension (200, 30));
				tCategory.setPreferredSize(new Dimension (200, 30));
				
				gbc.insets = new Insets(5,5,5,5);
				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.FIRST_LINE_START;
				gbc.weightx = 0.0;
				gbc.weighty = 0.0;
				gbl.setConstraints(l0, gbc);
				fieldPanel.add(l0);
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx = 1.0;
				gbl.setConstraints (lID, gbc);
				fieldPanel.add(lID);
				
				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.FIRST_LINE_START;
				gbc.weightx = 0.0;
				gbc.weighty = 0.0;
				gbl.setConstraints(l1, gbc);
				fieldPanel.add(l1);
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx = 1.0;
				gbl.setConstraints(tTitle, gbc);
				fieldPanel.add(tTitle);

				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.FIRST_LINE_START;
				gbc.weightx = 0.0;
				gbc.weighty = 0.0;
				gbl.setConstraints(l2, gbc);
				fieldPanel.add(l2);
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx = 1.0;
				gbl.setConstraints(tAuthor, gbc);
				fieldPanel.add(tAuthor);

				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.FIRST_LINE_START;
				gbc.weightx = 0.0;
				gbc.weighty = 0.0;
				gbl.setConstraints(l3, gbc);
				fieldPanel.add(l3);
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx = 1.0;
				gbl.setConstraints(tYear, gbc);
				fieldPanel.add(tYear);

				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.gridwidth = GridBagConstraints.FIRST_LINE_START;
				gbc.weightx = 0.0;
				gbc.weighty = 0.0;
				gbl.setConstraints(l4, gbc);
				fieldPanel.add(l4);
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.weightx = 1.0;
				gbl.setConstraints(tCategory, gbc);
				fieldPanel.add(tCategory);

				fieldPanel.setBorder(BorderFactory.createLineBorder(Color.black));
				
				funcPanel.setLayout(gbl);
				b1 = new JButton("Open");
				b2 = new JButton("Save");
				b3 = new JButton("Previous");
				b4 = new JButton("Next");
				b5 = new JButton("Insert");
				b6 = new JButton("Delete");
				b7 = new JButton("Quit");
				
				b1.setName("open");
				b2.setName("save");
				b3.setName("prev");
				b4.setName("next");
				b5.setName("new");
				b6.setName("delete");
				b7.setName("quit");
				
				gbc.gridwidth = 1;
				gbc.gridx = GridBagConstraints.RELATIVE;
				gbc.fill = GridBagConstraints.NONE;
				b1.addActionListener(mal);
				b2.addActionListener(mal);
				b3.addActionListener(mal);
				b4.addActionListener(mal);
				b5.addActionListener(mal);
				b6.addActionListener(mal);
				b7.addActionListener(mal);
				
				b1.setEnabled(true);
				b2.setEnabled(false);	
				b3.setEnabled(false);
				b4.setEnabled(false);
				b5.setEnabled(true);
				b6.setEnabled(false);
				b7.setEnabled(true);
				
				gbl.setConstraints(b1, gbc);
				funcPanel.add(b1);
				gbl.setConstraints(b2, gbc);
				funcPanel.add(b2);
				gbl.setConstraints(b3, gbc);
				funcPanel.add(b3);
				gbl.setConstraints(b4, gbc);
				funcPanel.add(b4);
				gbl.setConstraints(b5, gbc);
				funcPanel.add(b5);
				gbl.setConstraints(b6, gbc);
				funcPanel.add(b6);
				gbl.setConstraints(b7, gbc);
				funcPanel.add(b7);
				
				funcPanel.setBorder(BorderFactory.createLineBorder(Color.black));
				gbc.gridwidth = GridBagConstraints.REMAINDER;
				gbc.gridheight = GridBagConstraints.FIRST_LINE_START;
				gbc.fill = GridBagConstraints.BOTH;
				gbc.weightx = 1.0;
				gbc.weighty = 0.0;
				
				gbl.setConstraints(fieldPanel, gbc);
				add(fieldPanel);
				gbc.weighty = 0.0;
				gbc.gridwidth = GridBagConstraints.RELATIVE;
				gbl.setConstraints(funcPanel, gbc);
				add(funcPanel);
				pack();
				
				
		}
		
		
		public GUI() {
				// The constructor simply builds the GUI
				fc = new FilmCollection();
				buildGUI();
				setVisible(true);
		}
}
